// for inserting into collections look for "Working with Item Collections" in MSDN

#define INITGUID
#include <windows.h>
#include <pimstore.h>
#include <commdlg.h>

#include <iostream>
#include <fstream>
#include <sstream>

#include "xml.hpp"

extern HWND g_hWnd;
extern std::wstring errorstring;
IPOutlookApp *polApp=NULL;

int update(IPOutlookItemCollection *pItems, XML *node)
{
  if(!pItems)
  {
    errorstring=L"update(): pItems==0";
    return -1;
  }
  if(!node)
  {
    errorstring=L"update(): node==0";
    return -1;
  }

  if(!(node->nodeType == L"Entry"))
  {
    errorstring=L"update(): nodeType!=Entry : ";
    errorstring+=node->nodeType;
    return -1;
  }

  XML *namenode=node->firstChild;
  if(!namenode)
  {
    errorstring=L"update(): namenode==0";
    return -1;
  }
  if(!(namenode->nodeType == L"Name"))
  {
    errorstring=L"update(): namenode!=Name : ";
    errorstring+=namenode->nodeType;
    return -1;
  }

  std::wstring name=namenode->nodeData;

  std::wstring search=L"[FileAs] = \"";
  search+=name;
  search+=L"\"";
  IContact *c=NULL;
  HRESULT hr=pItems->Find(const_cast<wchar_t*>(search.c_str()), (IDispatch **) &c);
  if(FAILED(hr))
  {
    errorstring=L"update(): error while Find() : ";
    errorstring+=name;
    return -1;
  }
  if(c)
  {    
    hr=c->Delete();
    if(FAILED(hr))
    {
      errorstring=L"update(): could not Delete() : ";
      errorstring+=name;
      return -1;
    }
    c->Release();
  }

  std::wstring body;
  pItems->Add(reinterpret_cast<IDispatch**>(&c));
  if(!c)
  {
    errorstring=L"update(): could not Add()";
    return -1;
  }
  c->put_FileAs(const_cast<wchar_t*>(name.c_str()));
  for(XML *n=namenode->next; n; n=n->next)
  {
    if(n->nodeType == L"Subentry")
    {
      std::wstring key, value;
      for(XML *nn=n->firstChild; nn; nn=nn->next)
      {
	if(nn->nodeType == L"Key")
	  key=nn->nodeData;
	else if(nn->nodeType == L"Value")
	  value=nn->nodeData;
      }
      if(key == L"BusinessFaxNumber")
	c->put_BusinessFaxNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"CompanyName")
	c->put_CompanyName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Department")
	c->put_Department(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Email1Address")
	c->put_Email1Address(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"MobileTelephoneNumber")
	c->put_MobileTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OfficeLocation")
	c->put_OfficeLocation(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"PagerNumber")
	c->put_PagerNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessTelephoneNumber")
	c->put_BusinessTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"JobTitle")
	c->put_JobTitle(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeTelephoneNumber")
	c->put_HomeTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Email2Address")
	c->put_Email2Address(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Spouse")
	c->put_Spouse(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Email3Address")
	c->put_Email3Address(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Home2TelephoneNumber")
	c->put_Home2TelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeFaxNumber")
	c->put_HomeFaxNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"CarTelephoneNumber")
	c->put_CarTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"AssistantName")
	c->put_AssistantName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"AssistantTelephoneNumber")
	c->put_AssistantTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Children")
	c->put_Children(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Categories")
	c->put_Categories(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"WebPage")
	c->put_WebPage(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Business2TelephoneNumber")
	c->put_Business2TelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"RadioTelephoneNumber")
	c->put_RadioTelephoneNumber(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"YomiCompanyName")
	c->put_YomiCompanyName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"YomiFirstName")
	c->put_YomiFirstName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"YomiLastName")
	c->put_YomiLastName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Title")
	c->put_Title(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"FirstName")
	c->put_FirstName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"MiddleName")
	c->put_MiddleName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"LastName")
	c->put_LastName(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"Suffix")
	c->put_Suffix(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeAddressStreet")
	c->put_HomeAddressStreet(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeAddressCity")
	c->put_HomeAddressCity(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeAddressState")
	c->put_HomeAddressState(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeAddressPostalCode")
	c->put_HomeAddressPostalCode(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"HomeAddressCountry")
	c->put_HomeAddressCountry(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OtherAddressStreet")
	c->put_OtherAddressStreet(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OtherAddressCity")
	c->put_OtherAddressCity(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OtherAddressState")
	c->put_OtherAddressState(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OtherAddressPostalCode")
	c->put_OtherAddressPostalCode(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"OtherAddressCountry")
	c->put_OtherAddressCountry(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessAddressStreet")
	c->put_BusinessAddressStreet(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessAddressCity")
	c->put_BusinessAddressCity(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessAddressState")
	c->put_BusinessAddressState(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessAddressPostalCode")
	c->put_BusinessAddressPostalCode(const_cast<wchar_t*>(value.c_str()));
      else if(key == L"BusinessAddressCountry")
	c->put_BusinessAddressCountry(const_cast<wchar_t*>(value.c_str()));
      else
      {
	body+=key;
	body+=L": ";
	body+=value;
	body+=L"\r\n";
      }
    }
  }
  c->put_Body(const_cast<wchar_t*>(body.c_str()));
  c->Save();
  c->Release();

  return 0;
}

XML *loadxml()
{
  TCHAR filename[1024];
  
  OPENFILENAME lpofn;
  memset(&lpofn, 0, sizeof(lpofn));
  lpofn.lStructSize=sizeof(lpofn);
  lpofn.lpstrFilter=L"Input files\0*.XML\0\0\0";
  lpofn.lpstrFile=filename;
  lpofn.nMaxFile=sizeof(filename)/sizeof(filename[0]);
  lpofn.Flags=OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST;
  if(!GetOpenFileName(&lpofn))
    return 0;

  // set clog to a stringstream
  DS_NAMESPACE::streambuf *oldclog=DS_NAMESPACE::clog.rdbuf();
  DS_NAMESPACE::ostringstream errstream;
  DS_NAMESPACE::clog.rdbuf(errstream.rdbuf());

  // convert filename
  std::string fn; DS_NAMESPACE::unicode2latin(lpofn.lpstrFile, fn);
  DS_NAMESPACE::ifstream is(fn.c_str());

  // read xml
  XML *root=XML::parse(is);

  // reset clog
  DS_NAMESPACE::clog.rdbuf(oldclog);

  // look for error messages on error stringstream
  std::string err=errstream.str();
  if(err.size())
  {
    std::latin2unicode(err, errorstring);
    delete root;
    return 0;
  }

  return root;
}

int contacts(XML *node)
{
  errorstring=L"unknown error";

  HRESULT hr;
  polApp=NULL;
  IFolder *pFolder=NULL;
  IPOutlookItemCollection *pItems=NULL;

  // Initialize COM for Pocket Outlook
  if (FAILED(CoInitializeEx(NULL, 0)))
  {
    errorstring=L"contact(): could not init POOM";
    goto contactexit;
  }
  // Get the application object
  hr = CoCreateInstance(CLSID_Application, NULL, CLSCTX_INPROC_SERVER, IID_IPOutlookApp, (LPVOID *)&polApp);
  if (FAILED(hr))
  {
    errorstring=L"contact(): could not create polApp";
    goto contactexit;
  }

  // login
  hr = polApp->Logon((long) g_hWnd);
  if (FAILED(hr))
  {
    errorstring=L"contact(): could not Logon()";
    goto contactexit;
  }

#if 0
  // version into msgbox
  {
  BSTR pwszVersion = NULL;
  polApp->get_Version(&pwszVersion);
  MessageBox(NULL, pwszVersion, L"POOM Version", MB_SETFOREGROUND | MB_OK);
  SysFreeString(pwszVersion);
  }
#endif

  // get default folder
  polApp->GetDefaultFolder(olFolderContacts, &pFolder);
  if(!pFolder)
  {
    errorstring=L"contact(): could not GetDefaultFolder()";
    goto contactexit;
  }
  pFolder->get_Items(&pItems);
  if(!pItems)
  {
    errorstring=L"contact(): could not get_Items()";
    goto contactexit;
  }

  {// { needed, because of stupid MS compiler has buggy variable scope
    for(XML *n=node->firstChild; n; n=n->next)
      if(update(pItems, n) < 0)
	goto contactexit;
  }

  errorstring=L"all Contacts uploaded";

contactexit:
  // Release objects
  if(pItems)
    pItems->Release();
  if(pFolder)
    pFolder->Release();

  // logoff
  if(polApp)
  {
    polApp->Logoff();
    polApp->Release();
  }

  return 0;
}

DATE conv(int year, int month, int day, int hour)
{
  SYSTEMTIME st;
  memset(&st, 0, sizeof(SYSTEMTIME));
  st.wYear = year;
  st.wMonth = month;
  st.wDay = day;
  st.wHour = hour;
  DATE date=0;
  if(polApp)
    polApp->SystemTimeToVariantTime(&st, &date);
  return date;
}

DATE conv(std::wstring& str)
{
  if(!iswdigit(str[0]))
    return -1;
  if(!iswdigit(str[1]))
    return -1;
  if(!iswdigit(str[2]))
    return -1;
  if(!iswdigit(str[3]))
    return -1;
  if(str[4]!='-')
    return -1;
  if(!iswdigit(str[5]))
    return -1;
  if(!iswdigit(str[6]))
    return -1;
  if(str[7]!='-')
    return -1;
  if(!iswdigit(str[8]))
    return -1;
  if(!iswdigit(str[9]))
    return -1;

  int year=(str[0]-'0')*1000 + (str[1]-'0')*100 + (str[2]-'0')*10 + (str[3]-'0');
  int month=(str[5]-'0')*10 + (str[6]-'0');
  int day=(str[8]-'0')*10 + (str[9]-'0');
  int hour=0;
  unsigned i=10;
  while(i<str.size() && iswspace(str[i])) i++;

  if(iswdigit(str[i]) && iswdigit(str[i+1]))
    hour=(str[i]-'0')*10 + (str[i+1]-'0');

  if(year<1900 || year>2199)
    return -1;
  if(month<1 || month>12)
    return -1;
  if(day<1 || day>31)
    return -1;
  if(hour<0 || hour>24)
    return -1;
  if(hour==0)
    hour=10;

  return conv(year,month, day, hour);
}

int weekly(IPOutlookItemCollection *pItems, XML *node)
{
  // check
  if(!pItems)
    return -1;
  if(!node)
    return -1;
  if(!(node->nodeType==L"weekly"))
    return -1;

  // collect strings
  std::wstring von, bis, dow, name, description;
  for(XML *n=node->firstChild; n; n=n->next)
  {
    if(n->nodeType==L"von")
      von=n->nodeData;
    else if(n->nodeType==L"bis")
      bis=n->nodeData;
    else if(n->nodeType==L"dow")
      dow=n->nodeData;
    else if(n->nodeType==L"name")
      name=n->nodeData;
    else if(n->nodeType==L"description")
      description=n->nodeData;
  }

  if(name.empty())
    return -1;

  int dtab[] =
  {
    olSunday,
    olMonday,
    olTuesday,
    olWednesday,
    olThursday,
    olFriday,
    olSaturday,
    olSunday,
  };

  int dayofweek=_wtoi(dow.c_str());
  if(dayofweek<0 || dayofweek>sizeof(dtab)/sizeof(dtab[0]))
  {
    errorstring=L"wrong <dow> in weekly : ";
    errorstring+=name;
    errorstring+=L" ";
    errorstring+=dow;
    return -1;
  }

  int v=_wtoi(von.c_str());
  if(v<1 || v>24)
  {
vonwrong:
    errorstring=L"wrong <von> in weekly : ";
    errorstring+=name;
    errorstring+=L" ";
    errorstring+=von;
    return -1;
  }
  DATE date=conv(1905, 1, 1+dayofweek, v); // 1905 starts with a sunday
  if(date<0)
    goto vonwrong;

  int b=_wtoi(bis.c_str());
  if(b<1 || b>24 || b<=v)
  {
biswrong:
    errorstring=L"wrong <bis> in weekly : ";
    errorstring+=name;
    errorstring+=L" ";
    errorstring+=bis;
    return -1;
  }
  DATE end=conv(1905, 1, 1+dayofweek, b);
  if(end<0)
    goto biswrong;

  // insert
  IAppointment *a=NULL;
  pItems->Add(reinterpret_cast<IDispatch**>(&a));
  if(!a)
  {
    errorstring=L"could not Add()";
    return -1;
  }

  a->put_Start(date);
  a->put_End(end);
  a->put_Subject(const_cast<wchar_t*>(name.c_str()));
  a->put_Location(L"weekly");
  a->put_Body(const_cast<wchar_t*>(description.c_str()));

  // search for "IRecurrencePattern Property Methods" in MSDN
  IRecurrencePattern *pRec=NULL;
  a->GetRecurrencePattern(&pRec);
  if(pRec)
  {
    pRec->put_RecurrenceType(olRecursWeekly);
    pRec->put_DayOfWeekMask(dtab[dayofweek]);
    pRec->put_NoEndDate(true);
  }

  a->Save();
  if(pRec)
    pRec->Release();
  a->Release();

  return 0;
}
int yearly(IPOutlookItemCollection *pItems, XML *node)
{
  // check
  if(!pItems)
    return -1;
  if(!node)
    return -1;
  if(!(node->nodeType==L"yearly"))
    return -1;

  // collect strings
  std::wstring day, month, name, description;
  for(XML *n=node->firstChild; n; n=n->next)
  {
    if(n->nodeType==L"day")
      day=n->nodeData;
    else if(n->nodeType==L"month")
      month=n->nodeData;
    else if(n->nodeType==L"name")
      name=n->nodeData;
    else if(n->nodeType==L"description")
      description=n->nodeData;
  }

  if(name.empty())
    return -1;

  // construct date
  int d=_wtoi(day.c_str());
  if(d<1 || d>31)
  {
    errorstring=L"wrong day in yearly : ";
    errorstring+=name;
    return -1;
  }

  int m=_wtoi(month.c_str());
  if(m<1 || m>12)
  {
    errorstring=L"wrong month in yearly : ";
    errorstring+=name;
    return -1;
  }

  SYSTEMTIME stime;
  GetSystemTime(&stime);
  int y=stime.wYear;

  DATE date=conv(y, m, d, 10);
  if(date<0)
    return -1;

  // insert
  IAppointment *a=NULL;
  pItems->Add(reinterpret_cast<IDispatch**>(&a));
  if(!a)
  {
    errorstring=L"could not Add()";
    return -1;
  }

  a->put_Start(date);
  a->put_Subject(const_cast<wchar_t*>(name.c_str()));
  a->put_Location(L"yearly");
  a->put_Body(const_cast<wchar_t*>(description.c_str()));

  // search for "IRecurrencePattern Property Methods" in MSDN
  IRecurrencePattern *pRec=NULL;
  a->GetRecurrencePattern(&pRec);
  if(pRec)
  {
    pRec->put_RecurrenceType(olRecursYearly);
    pRec->put_DayOfMonth(d);
    pRec->put_MonthOfYear(m);
    pRec->put_NoEndDate(true);
  }

  a->Save();
  if(pRec)
    pRec->Release();
  a->Release();

  return 0;
}
int upd(IPOutlookItemCollection *pItems, XML *node)
{
  if(!pItems)
    return -1;
  if(!node)
    return -1;

  if(node->nodeType==L"weekly")
    return weekly(pItems, node);
  if(node->nodeType==L"yearly")
    return yearly(pItems, node);

  if(!(node->nodeType==L"event"))
  {
    errorstring=L"nodeType!=event : ";
    errorstring+=node->nodeType;
    return -1;
  }

  std::wstring name, description, start, end, account;
  for(XML *n=node->firstChild; n; n=n->next)
  {
    if(n->nodeType==L"start")
      start=n->nodeData;
    else if(n->nodeType==L"end")
      end=n->nodeData;
    else if(n->nodeType==L"name")
      name=n->nodeData;
    else if(n->nodeType==L"description")
      description=n->nodeData;
    else if(n->nodeType==L"account")
      account=n->nodeData;
  }

  if(name.empty())
    return -1;

  DATE s=conv(start);
  if(s<0)
    return -1;

  IAppointment *a=NULL;
  pItems->Add(reinterpret_cast<IDispatch**>(&a));
  if(!a)
  {
    errorstring=L"could not Add()";
    return -1;
  }

  a->put_Start(s);

  if(!(start==end))
  {
    DATE e=conv(end);
    if(e>0)
      a->put_End(e);
  }

  a->put_Subject(const_cast<wchar_t*>(name.c_str()));
  a->put_Location(const_cast<wchar_t*>(account.c_str()));
  a->put_Body(const_cast<wchar_t*>(description.c_str()));
  a->Save();
  a->Release();

  return 0;
}

int dates(XML *node)
{
  errorstring=L"unknown error";

  HRESULT hr;
  polApp=NULL;
  IFolder *pFolder=NULL;
  IPOutlookItemCollection *pItems=NULL;

  // Initialize COM for Pocket Outlook
  if (FAILED(CoInitializeEx(NULL, 0)))
  {
    errorstring=L"contact(): could not init POOM";
    goto datesexit;
  }
  // Get the application object
  hr = CoCreateInstance(CLSID_Application, NULL, CLSCTX_INPROC_SERVER, IID_IPOutlookApp, (LPVOID *)&polApp);
  if (FAILED(hr))
  {
    errorstring=L"contact(): could not create polApp";
    goto datesexit;
  }

  // login
  hr = polApp->Logon((long) g_hWnd);
  if (FAILED(hr))
  {
    errorstring=L"contact(): could not Logon()";
    goto datesexit;
  }

  // get default folder
  polApp->GetDefaultFolder(olFolderCalendar, &pFolder);
  if(!pFolder)
  {
    errorstring=L"contact(): could not GetDefaultFolder()";
    goto datesexit;
  }
  pFolder->get_Items(&pItems);
  if(!pItems)
  {
    errorstring=L"contact(): could not get_Items()";
    goto datesexit;
  }

  { // and once again we need an { because Microsoft did not fix it

    // delete all appointments
    int count;
    pItems->get_Count(&count);
    for(int i=count-1; i>=0; --i)
    {
      IAppointment *a=NULL;
      hr=pItems->Item(i, reinterpret_cast<IDispatch **>(&a));
      if(!FAILED(hr) && a)
      {
	a->Delete();
	a->Release();
      }
    }

    // and insert the fresh ones
    for(XML *n=node->firstChild; n; n=n->next)
      if(upd(pItems, n) < 0)
	goto datesexit;
  }

  errorstring=L"all dates imported";

datesexit:
  // Release objects
  if(pItems)
    pItems->Release();
  if(pFolder)
    pFolder->Release();

  // logoff
  if(polApp)
  {
    polApp->Logoff();
    polApp->Release();
  }

  return 0;
}

int import()
{
  XML *node, *root=loadxml();

  // get the right node
  if(!root)
    goto importexit;

  node=root->firstChild;
  if(!node)
  {
    errorstring=L"node==0";
    goto importexit;
  }

  if(node->nodeType == L"dates")
    dates(node);
  else if(node->nodeType == L"AddressBook")
    contacts(node);
  else
  {
    errorstring=L"unknown XML node : ";
    errorstring+=node->nodeType;
  }

importexit:
  if(root)
    delete root;

  return 0;
}