#ifndef DS_FSTREAM__HPP
#define DS_FSTREAM__HPP

#include <../ds_ifstream.hpp>
#include <../ds_ofstream.hpp>

namespace DS_NAMESPACE
{
  template <TYPENAME charT>
  class basic_fstream : public basic_ifstream<charT>, public basic_ofstream<charT>
  {
  public:
    basic_fstream<charT>(const char *f=0, int flags=0)
    {
      this->open(f, flags);
    }

    basic_fstream<charT>(FILE *file)
    {
      this->open(file);
    }
  };

  typedef basic_fstream<char> fstream;
  typedef basic_fstream<wchar_t> wfstream;
}

#endif
