#ifndef DS_FSTREAMHELPER__HPP
#define DS_FSTREAMHELPER__HPP

#include <ds_fixcompiler.hpp>
#include <ds_filebuf.hpp>
#include <string>

namespace DS_NAMESPACE
{
  template <TYPENAME bufT>
  class basic_fstreamhelper
  {
  protected:
    bufT *mysb;
    size_t pos() { return mysb->pos(); }
  public:
    basic_fstreamhelper<bufT> () 
      : mysb(new bufT) 
    { 
      ds_debughook("basic_fstreamhelper()");
    }

    ~basic_fstreamhelper<bufT>()
    {
      ds_debughook("~basic_fstreamhelper()");
      if(mysb->delref()<0)
	{
	  ds_debughook("~basic_fstreamhelper(): delete");
	  delete mysb;
	}
    }

    bool open(const char *f, int flags=0) { return mysb->open(f, flags); }
    bool open(FILE *file) { return mysb->open(file); }
    bool close() { return mysb->close(); }
    bool is_open() { return mysb->is_open(); }
  };

  struct fstream_traits_not_implemented { }; 
  template <TYPENAME charT>
  class fstream_traits
  {
  public: typedef fstream_traits_not_implemented sb_t;
  };

  template <>
  class fstream_traits<char>
  {
  public: typedef basic_filebuf sb_t;
  };

  template <>
  class fstream_traits<wchar_t>
  {
  public: typedef basic_wfilebuf sb_t;
  };

}

#endif
