#ifndef DS_IFSTREAM__HPP
#define DS_IFSTREAM__HPP

#include <ds_basicistream.hpp>
#include <ds_fstreamhelper.hpp>

namespace DS_NAMESPACE
{
  template <TYPENAME charT>
  class basic_ifstream : public virtual basic_istream<charT>, public virtual basic_fstreamhelper< typename fstream_traits<charT>::sb_t >
  {
  protected:
    typedef basic_fstreamhelper< typename fstream_traits<charT>::sb_t > streamhelper_t;
  public:
    basic_ifstream<charT>(const char *f=0, int flags=0)
    { 
      this->init(mysb);
      this->open(f, flags);
    }

    /**
       @param dcsb a private flag, that is only set when ifstream is used as cin
    */
    basic_ifstream<charT>(FILE *file, const bool dcsb=false)
    { 
      this->init(mysb, dcsb);
      this->open(file);
    }
    bool open(const char *f, int flags=0) { return streamhelper_t::open(f, flags|ios_base::in); }
    bool open(FILE *file) { return streamhelper_t::open(file); }
  };

  typedef basic_ifstream<char> ifstream;
  typedef basic_ifstream<wchar_t> wifstream;
}

#endif
