#ifndef DS_IOSTREAM__HPP
#define DS_IOSTREAM__HPP

#include <ds_basicostream.hpp>
#include <ds_basicistream.hpp>
#include <ds_streamiterator.hpp>

namespace DS_NAMESPACE
{
  extern istream cin;
  extern ostream cout;
  extern ostream cerr;
  extern ostream clog;
  extern wistream wcin;
  extern wostream wcout;
  extern wostream wcerr;
  extern wostream wclog;

  void unicode2latin(const std::wstring& u, std::string& l);
  void latin2unicode(const std::string& l, std::wstring& u);

  static ios_base::Init __ds_globalinit;

  template <TYPENAME charT>
  class basic_iostream : public basic_istream<charT>, public basic_ostream<charT>
  {
  public:
    basic_iostream<charT>(streambuf *s=0)
      : basic_istream<charT>(0), basic_ostream<charT>(s)
    { }
  };

  typedef basic_iostream<char> iostream;
  typedef basic_iostream<wchar_t> wiostream;
}

#endif
