#ifndef DS_ISTRINGSTREAM__HPP
#define DS_ISTRINGSTREAM__HPP

#include <ds_basicistream.hpp>
#include <ds_stringstreamhelper.hpp>

namespace DS_NAMESPACE
{
  template <TYPENAME charT>
  class basic_istringstream : public virtual basic_istream<charT>, public virtual basic_stringstreamhelper< charT, typename stringstream_traits<charT>::sb_t >
  {
  public:
    basic_istringstream<charT>()
    {
      this->init(mysb);
    }
    basic_istringstream<charT>(const std::basic_string<charT>& s)
    {
      this->init(mysb);
      this->str(s);
    }
  };

  typedef basic_istringstream<char> istringstream;
  typedef basic_istringstream<wchar_t> wistringstream;
}

#endif
