#ifndef DS_OFSTREAM__HPP
#define DS_OFSTREAM__HPP

#include <ds_basicostream.hpp>
#include <ds_fstreamhelper.hpp>

namespace DS_NAMESPACE
{
  template <TYPENAME charT>
  class basic_ofstream : public virtual basic_ostream<charT>, public virtual basic_fstreamhelper< typename fstream_traits<charT>::sb_t >
  {
  protected:
    typedef basic_fstreamhelper< typename fstream_traits<charT>::sb_t > streamhelper_t;
  public:
    basic_ofstream<charT>(const char *f=0, int flags=0)
    {
      this->init(mysb);
      this->open(f, flags);
    }

    /**
       @param dcsb a private flag that is only set when ofstream is used as cout
    */
    basic_ofstream<charT>(FILE *file, const bool dcsb=false)
    { 
      this->init(mysb, dcsb);
      this->open(file);
    }
    bool open(const char *f, int flags=0) { return streamhelper_t::open(f, flags|ios_base::out); }
    bool open(FILE *file) { return streamhelper_t::open(file); }
  };

  typedef basic_ofstream<char> ofstream;
  typedef basic_ofstream<wchar_t> wofstream;
}

#endif
