#ifndef STRINGBUF__HPP
#define STRINGBUF__HPP

#include <ds_streambuf.hpp>
#include <string>

namespace DS_NAMESPACE
{

  template <TYPENAME charT>
  class basic_stringbufhelper : public streambuf
  {
  public:
    size_t pos_;
    typedef std::basic_string<charT>  str_t;
    str_t str_;
    basic_stringbufhelper<charT>() : pos_(0) { }
    const str_t& str() const { return str_; }
    basic_stringbufhelper<charT>& str(const str_t& s) { str_=s; return *this; }
  };

  class basic_stringbuf : public basic_stringbufhelper<char>
  {
  public:
    virtual int get();
    virtual int put(const int c);
    virtual int seek(const streamoff offs, const ios_base::seek_dir flag);
    virtual int flush();
    virtual streampos pos();
  };
  
  class basic_wstringbuf : public basic_stringbufhelper<wchar_t>
  {
  public:
    virtual int get();
    virtual int put(const int c);
    virtual int seek(const streamoff offs, const ios_base::seek_dir flag);
    virtual int flush();
    virtual streampos pos();
  };
  
}

#endif
