#include "inc.hpp"
#include <math.h>
#include <string.h>

std::string suffix;

void fullrange()
{
  ios::fmtflags tab[] = {
    ios::left,
    ios::right,
    ios::internal,
    static_cast<ios::fmtflags>(ios::left|ios::right),
    static_cast<ios::fmtflags>(ios::left|ios::internal),
    static_cast<ios::fmtflags>(ios::right|ios::internal),
    static_cast<ios::fmtflags>(ios::left|ios::right|ios::internal),
    static_cast<ios::fmtflags>(0)
  };

  static int tabi=0;

  const unsigned int add=82734223;

  cout << "unsigned" << endl;
  unsigned int i=0;
  cout << i << endl;
  i+=add+1;
  while(i>add)
    {
      cout.setf(tab[tabi++], ios::adjustfield);
      tabi%=sizeof(tab)/sizeof(tab[0]);

      cout << setw(-10) << i << endl;
      i+=add;
    }

  cout << "signed" << endl;
  int j=0;
  cout << j << endl;
  j+=add+1;
  cout << setfill('$');
  while(j>(int)add || j<0)
    {
      cout.setf(tab[tabi++], ios::adjustfield);
      tabi%=sizeof(tab)/sizeof(tab[0]);

      cout << setw(40) << j << endl;
      j+=add;
    }
  cout << setfill(' ');
}

void fullbase()
{
  ios::fmtflags tab[] = {
    ios::dec,
    ios::oct,
    ios::hex,
    ios::dec | ios::oct,
    ios::dec | ios::hex,
    ios::oct | ios::hex,
    ios::dec | ios::oct | ios::hex,
  };

  char* str[] = {
    "dec",
    "oct",
    "hex",
    "dec|oct",
    "dec|hex",
    "oct|hex",
    "dec|oct|hex",
  };

  for(int i=0; i<7; i++)
    {
      cout << "format : " << str[i] << endl;
      cout.setf(tab[i], ios::basefield);
      fullrange();
    }

  cout.unsetf(ios::dec);
  cout.unsetf(ios::oct);
  cout.unsetf(ios::hex);
  fullrange();

  dec(cout);
}

void testnumbers()
{
  cout << "testnumbers()" << endl;

  cout << "showpos" << endl << showpos;
  fullbase();
  cout << noshowpos;

  cout << "showbase" << endl << showbase;
  fullbase();
  cout << noshowbase;

  cout << "uppercase" << endl << uppercase;
  fullbase();
  cout << nouppercase;


  cout << "showpos" << endl << showpos;
  cout << "showbase" << endl << showbase;
  fullbase();
  cout << noshowpos;
  cout << noshowbase;

  cout << "showpos" << endl << showpos;
  cout << "uppercase" << endl << uppercase;
  fullbase();
  cout << nouppercase;
  cout << noshowpos;

  cout << "showbase" << endl << showbase;
  cout << "uppercase" << endl << uppercase;
  fullbase();
  cout << nouppercase;
  cout << noshowbase;


  cout << "showpos" << endl << showpos;
  cout << "showbase" << endl << showbase;
  cout << "uppercase" << endl << uppercase;
  fullbase();
  cout << nouppercase;
  cout << noshowbase;
  cout << noshowpos;
}

void primetest()
{
  const size_t max=100;
  char *space=new char[max];
  memset(space, 1, max);
  // calculate some primes
  const size_t sq=static_cast<size_t>(sqrt(static_cast<float>(max))+1.0f);
  size_t i=2;
  while(i<=sq)
    {
      for(size_t x=i+i; x<max; x+=i)
	space[x]=0;
      while(space[++i]==0);
    }

  std::string filename="prime";
  if(suffix.size())
    {
      filename+='.';
      filename+=suffix;
    }

  {
    ofstream os(filename.c_str());
    for(i=0; i<max; i++)
      if(space[i])
	os << i << endl;
  }

  char *space2=new char[max];
  memset(space2, 0, max);
  {
    ifstream is(filename.c_str());
    int x;
    while(is>>x)
      if(x<0 || x>(int)max)
	cout << "error in primetest(): read " << x << endl;
      else
	space2[x]=1;
  }

  for(i=0; i<max; i++)
    if(space[i]!=space2[i])
      cout << "error in primetest(): mismatch " << i << '(' << (int)space[i] << ',' << (int)space2[i] << ')' << endl;

  delete [] space2;
  delete [] space;
}

void testss()
{
  int i;
  const int max=3;
  const char* tab[max] = {
    "hallo",
    "",
    "!$$%&/%&/()()=?",
  };

  ostringstream os;
  for(i=0; i<max; i++)
    os << tab[i] << ' ';

  istringstream is(os.str());
  std::string s;
  i=0;
  while(is >> s)
    {
      if(s!=tab[i])
	cerr << "testss() mismatch1: '" << s << "' '" << tab[i] << "'" << endl;
      i++;
    }

  ostringstream os2;
  streambuf *sb=cout.rdbuf(os2.rdbuf());
  for(i=0; i<max; i++)
    cout << tab[i] << ' ';

  istringstream is2(os2.str());
  streambuf *sb2=cin.rdbuf(is2.rdbuf());
  i=0;
  while(cin >> s)
    {
      if(s!=tab[i])
	cerr << "testss() mismatch2: " << s << " " << tab[i] << endl;
      i++;
    }

  cout.rdbuf(sb);
  cin.rdbuf(sb2);
}

int main(char argc, char **argv)
{
#ifdef USESTRING
  teststring();
#endif

#if 0
  streambuf *sb=cout.rdbuf();
  cin.get(*sb, '');
  return 0;
#endif

#if 1
  if(argc>1)
    suffix=argv[1];

  std::string filename="num.";
  filename+=suffix;

  {
    ofstream os(filename.c_str());
    streambuf *sb=cout.rdbuf(os.rdbuf());
    testnumbers();
    cout.rdbuf(sb);
  }

  testss();
  primetest();
#endif
  return 0;
}
